<?php

namespace Rezzza\ModelViolationLoggerBundle\DependencyInjection;

use Symfony\Component\Config\FileLocator;
use Symfony\Component\HttpKernel\DependencyInjection\Extension;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Loader\XmlFileLoader;
use Symfony\Component\Config\Definition\Processor;

class RezzzaModelViolationLoggerExtension extends Extension
{
    /**
     * {@inheritdoc}
     */
    public function load(array $configs, ContainerBuilder $container)
    {
        $processor     = new Processor();
        $configuration = new Configuration();

        $config = $processor->processConfiguration($configuration, $configs);

        $loader = new XmlFileLoader($container, new FileLocator(__DIR__.'/../Resources/config/services'));
        $loader->load(sprintf('%s.xml', $config['storage']));
        $loader->load('handler.xml');

        $container->setAlias('rezzza.violation_manager', $config['violation_manager']);
        $container->setParameter('rezzza.violation_class', $config['violation_class']);
    }
}
